<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_USER_COL') ){
	class WPO_pressticket_User {
		function __construct() {
			add_filter('manage_users_columns', array($this,'add_apicol'));
			add_action('manage_users_custom_column',  array($this,'add_apicol_data'), 10, 3);
		}
		function add_apicol($columns){
			$columns['pressapikey'] = __('APIkey','wpo');
			return $columns;
		}
		function add_apicol_data($value, $column_name, $user_id){
			switch ($column_name) {
				case 'pressapikey':
					return sprintf('<a href="%s">'.__('Get One','wpo').'</a>', admin_url('edit.php?s='.$user_id.'&page=wp-ticket-settings&post_type=wp-ticket&action=search-user&tab=permission') );
				break;
			}
		}
	}
	new WPO_pressticket_User();
}