<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_admin_notices') ){
	class WPO_pressticket_admin_notices {
		function __construct(){
			add_action('admin_notices', array($this,'warm_delete_ticket'));
			add_action('admin_notices', array($this,'warm_recaptcha'));
		}
		function warm_delete_ticket() {
			if($_GET['post_type']=='wp-ticket' && $_GET['post_status']=='trash'){
	    		_e('<div class="updated"><p>Be careful, if delete the items, all the Responses of this items will be deleted, and You can not rollback.<br/>You can delete the item spam or nonsense content.</p></div>','wpo');			
			}			
		}
		function warm_recaptcha() {
			if( wpo_ticket_option_enable_recaptcha()=='yes' ){
				if( wpo_ticket_option_recaptcha_publish_key()=='' || wpo_ticket_option_recaptcha_private_key()=='' ){
					_e('<div class="updated"><p>You had enable Re-captcha, but not provide <strong>Public Key/Private Key</strong>, please <a href="'.get_bloginfo('url').'/wp-admin/edit.php?post_type=wp-ticket&page=wp-ticket-settings">fix it</a>!</p></div>','wpo');
				}
			}			
		}
	}
	$WPO_pressticket_admin_notices = new WPO_pressticket_admin_notices();
}