<?php 
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_posttype') ){
	class WPO_pressticket_posttype {
		function __construct(){
			add_action('init', array($this,'register_post_type'),10);
		}
		function register_post_type() {
			register_post_type('wp-ticket', 
			array(
				'label' => __('PressTicket','wpo'),
				'description' => '',
				'public' => true,
				'show_ui' => true,
				'show_in_menu' => true,
				'capability_type' => 'post',
				'hierarchical' => false,
				'rewrite' => array('slug' => wpo_ticket_option_slug()),
				'query_var' => true,
				'exclude_from_search' => false,
				'supports' => array('title','editor','author'),
				'menu_icon'	=>	WPO_PRESSTICKET_PLUGIN_URL . '/assets/img/icon_helpdesk_16.png',
				'labels' => array (
			  'name' => __('PressTicket','wpo'),
			  'singular_name' => __('PressTicket','wpo'),
			  'menu_name' => __('PressTicket','wpo'),
			  'add_new' => __('Add New Ticket','wpo'),
			  'add_new_item' => __('Add New Ticket','wpo'),
			  'edit' => __('Edit','wpo'),
			  'edit_item' =>__('Edit Ticket','wpo'),
			  'new_item' => __('New Ticket','wpo'),
			  'view' => __('View Ticket','wpo'),
			  'view_item' => __('View Ticket','wpo'),
			  'search_items' => __('Search Ticket','wpo'),
			  'not_found' => __('No Ticket Found!','wpo'),
			  'not_found_in_trash' => __('No Ticket Found in Trash','wpo'),
			  'parent' => __('Parent Ticket','wpo'),
			),) );
		}		
	}
	$WPO_pressticket_posttype = new WPO_pressticket_posttype();
}