<?php
if( !defined('ABSPATH') )
	exit();
error_reporting(0);
/**
 * Plugin Name: PressTicket (Share on 20script.ir)
 * Author: Toan 20script
 * Author URI: http://www.20script.ir/
 * Version: 2.3.1
 * Plugin URI: http://www.20script.ir
 * Description: Advanced Helpdesk Plugin For Wordpress.
 */
if( !defined('WPO_PRESSTICKET_PLUGIN_URL') )
	define('WPO_PRESSTICKET_PLUGIN_URL', plugin_dir_url(__FILE__) );
if( !defined('WPO_PRESSTICKET_PLUGIN_DIR') )
	define('WPO_PRESSTICKET_PLUGIN_DIR', plugin_dir_path(__FILE__) );

if( !class_exists('WPO_purchasekey_verifier') )
	require_once 'classes/WPO_purchasekey_verifier.php';
require_once 'classes/WPO_pressticket_ENQUEUE.php';
require_once 'classes/WPO_pressticket_posttype.php';
require_once 'classes/WPO_pressticket_taxonomy.php';
require_once 'classes/wp-tax-meta.php';
require_once 'classes/WPO_pressticket_Shortcode.php';
require_once 'classes/WPO_pressticket_Tickets.php';
require_once 'classes/wp-response.php';
require_once 'classes/WPO_pressticket_admin_notices.php';
require_once 'classes/WPO_pressticket_schedule.php';
require_once 'classes/WPO_ticket_quickview_widget.php';
require_once 'classes/WPO_pressticket_RepairMetafields.php';
require_once 'classes/WPO_pressticket_Dashboard.php';
require_once 'classes/WPO_pressticket_Chart.php';
require_once 'classes/PT_API_Endpoint.php';
require_once 'classes/WPO_pressticket_API_KEY.php';
require_once 'classes/WPO_pressticket_User.php';
require_once 'classes/WPO_pressticket_METABOX.php';
require_once 'functions/options.php';
require_once 'functions/ajax.php';
require_once 'functions/ajax-debug.php';
require_once 'functions/permission.php';
require_once 'functions/single.php';
require_once 'functions/responses.php';
require_once 'functions/settings.php';
require_once 'functions/functions.php';
require_once 'mail/templates.php';
if( !class_exists('WPO_pressticket_woocommerce') )
	require_once 'classes/WPO_pressticket_woocommerce.php';	
if( !class_exists('WPO_pressticket_installme') )
	require_once 'classes/WPO_pressticket_Install.php';
if( !class_exists('WPO_pressticket_notifications') )
	require_once 'classes/WPO_pressticket_notifications.php';
require_once 'classes/WPO_pressticket_Networks.php';
if(!function_exists('wpo_ticket_install')){
	function wpo_ticket_install() {
		if(class_exists('WPO_pressticket_Install')){
			$WPO_pressticket_Install = new WPO_pressticket_Install();
			$WPO_pressticket_Install->upgrade();
		}
	}	
	register_activation_hook(__FILE__, 'wpo_ticket_install');
}
if(!function_exists('wpo_ticket_load_lang')){
	function wpo_ticket_load_lang() {
		load_plugin_textdomain('wpo',false,dirname( plugin_basename( __FILE__ ) ) . '/language');	
	}
	add_action('plugins_loaded', 'wpo_ticket_load_lang');
}
if(!function_exists('wpo_ticket_load_recaptcha')){
	function wpo_ticket_load_recaptcha() {
		if( !function_exists('_recaptcha_qsencode') && !function_exists('recaptcha_get_html') && !class_exists('ReCaptchaResponse') ){
			require 'classes/recaptcha-php-1.11/recaptchalib.php';
		}		
	}
	add_action('init', 'wpo_ticket_load_recaptcha', 1);
}
if(!function_exists('wpo_ticket_add_menus')){
	function wpo_ticket_add_menus() {
		add_submenu_page('edit.php?post_type=wp-ticket', __('Responses','wpo'), __('Responses','wpo'), wpo_ticket_cap_update_ticket(), 'new-reply','wpo_ticket_response_table');
		add_submenu_page('edit.php?post_type=wp-ticket', __('Settings','wpo'), __('Settings','wpo'), 'add_users', 'wp-ticket-settings','wpo_ticket_settings');
	}
	add_action('admin_menu', 'wpo_ticket_add_menus');
}
if(!function_exists('wpo_ticket_get_priority_options')){
	function wpo_ticket_get_priority_options($key = NULL){
		$priority = array(
			'low'	=>	__('Low','wpo'),
			'normal'	=>	__('Normal','wpo'),
			'high'	=>	__('High','wpo'),
			'emergency'	=>	__('Emergency','wpo')
		);
		if( $key != null )
			return $priority[$key];
		return apply_filters('wpo_ticket_get_priority_options', $priority);
	}
}
if( !function_exists('remove_low_priority') ){
	function remove_low_priority($priority){
		unset( $priority['low'] );
		return $priority;
	}
	//add_filter('wpo_ticket_get_priority_options', 'remove_low_priority');
}
if(!function_exists('wpo_ticket_get_status_options')){
	function wpo_ticket_get_status_options($key = NULL){
		$status = array(
			'open'	=>	__('Open','wpo'),
			'close'	=>	__('Closed','wpo'),
			'resolved'	=>	__('Resolved','wpo')
		);
		if( $key !=null )
			return $status[$key];
		return apply_filters('wpo_ticket_get_status_options', $status);
	}
}
if(!function_exists('wpo_ticket_yesno')){
	function wpo_ticket_yesno() {
		$yesno = array(
			'yes'	=>	__('Yes','wpo'),
			'no'	=>	__('No','wpo')
		);
		return apply_filters('wpo_ticket_yesno', $yesno);
	}
}
if(!function_exists('wpo_ticket_hightlight_status')){
	function wpo_ticket_hightlight_status($status) {
		return '<label class="label '.$status.'">'.wpo_ticket_get_status_options($status).'</label>';
	}
}
if(!function_exists('wpo_ticket_get_ticket_status')){
	function wpo_ticket_get_ticket_status($post_id, $key = true) {
		$status = wpo_ticket_get_status_options();
		$get_status = get_post_meta($post_id,'wpo_ticket_status',true) ? get_post_meta($post_id,'wpo_ticket_status',true) : 'open';
		if( $key !== true )
			return $status[$get_status];
		return $get_status;
	}
}
if(!function_exists('wpo_ticket_get_ticket_priority')){
	function wpo_ticket_get_ticket_priority($post_id, $key=TRUE) {
		$priority = wpo_ticket_get_priority_options();
		$get_priority = get_post_meta($post_id,'wpo_ticket_priority',true) ? get_post_meta($post_id,'wpo_ticket_priority',true) : 'normal';
		if( $key !==true )
			return $priority[$get_priority];
		return $get_priority;
	}
}

if(!function_exists('wpo_ticket_hightlight_priority')){
	function wpo_ticket_hightlight_priority($priority) {
		return '<label class="label '.$priority.'">'.wpo_ticket_get_priority_options($priority).'</label>';
	}
}
if(!function_exists('wpo_ticket_get_reply')){
	function wpo_ticket_get_reply($post_id) {
		global $wpdb;
		$order = wpo_ticket_option_ticket_thread_order();
		$query = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE `comment_post_ID`=$post_id ORDER BY `comment_ID` $order", ARRAY_A);
		return $query;
	}	
}
if(!function_exists('wpo_ticket_get_author_id_post_id')){
	function wpo_ticket_get_author_id_post_id($post_id) {
		if( !$post_id )
			return;
		$post = get_post($post_id);
		return $post->post_author;
	}
}
//======================== settings =================================
//======================= end settings ==============================

//======================= remove menu================================
if(!function_exists('wpo_ticket_deny_access_createnew')){
	function wpo_ticket_deny_access_createnew() {
		global $pagenow;
		if( $pagenow=='post-new.php' && $_GET['post_type']=='wp-ticket' ){
			//wp_die('Sorry!, Do You want create new ticket? it not available in backend! try it <a href="'.wpo_ticket_get_url_createticket().'">here</a>','ERROR');
			wp_redirect( wpo_ticket_get_url_createticket() );exit();
		}
		//remove_submenu_page('post-new.php?post_type=wp-ticket');
	}
	//add_action('admin_init', 'wpo_ticket_deny_access_createnew');
	//add_action('admin_menu', 'wpo_ticket_deny_access_createnew',999);
}
//======================= end remove menu============================
if(!function_exists('wpo_ticket_count_reply')){
	function wpo_ticket_count_reply($post_id) {
		global $wpdb;
		$query = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE `comment_post_ID`=$post_id");
		if($query) return $query;
		else return 0;
	}
}
if(!function_exists('wpo_ticket_get_plugin_data')){
	function wpo_ticket_get_plugin_data() {
		return get_plugin_data(__FILE__);
	}
}
if(!function_exists('wpo_ticket_get_tax_meta')){
	/**
	 * Get taxonomy meta
	 * @param int $tax_id
	 * return array
	 */
	function wpo_ticket_get_tax_meta($tax_id) {
		if(!$tax_id) return;
		return get_option('tax_meta_' . $tax_id);
	}
}

if(!function_exists('wpo_ticket_get_helpers')){
	/**
	 * Get User Id from department
	 * @param int $department_id
	 * return array
	 */
	function wpo_ticket_get_helpers($department_id) {
		$helpers = wpo_ticket_get_tax_meta($department_id);
		if($helpers){
			foreach ($helpers as $k=>$v){
				if(substr($k, 0, 24)=='wp_ticket_tax_helper_id_'){
					$helpers_id[] = substr($k, 24);	
				}
			}
		}
		return $helpers_id;
	}
}
if(!function_exists('wpo_ticket_get_helptopics')){
	/**
	 * Get help topics of department
	 * @param int $department_id
	 * @return array
	 */
	function wpo_ticket_get_helptopics($department_id){
		if(!$department_id) return FALSE;	
		$helptopics = wpo_ticket_get_tax_meta($department_id);
		if($helptopics){
			$topics = $helptopics['wp_ticket_taxhelps_'];
			if(is_array($topics)){
				for ($i=0; $i<count($topics);$i++){
					$topic[] = $topics[$i]['wp_ticket_tax_topics_id_' . $department_id];
				}
			}
		}
		return $topic;
	}
}
//print_r(get_option('tax_meta_7'));
function wpse27856_set_content_type(){
    return "text/html";
}
//add_filter( 'wp_mail_content_type','wpse27856_set_content_type' );
if(!function_exists('wpo_ticket_check_limit_ticketbox')){
	/**
	 * Check full ticketbox
	 * @param int $user_id
	 * if full, return false, else return true;
	 */
	function wpo_ticket_check_limit_ticketbox($user_id) {
		if( !$user_id ) return;
		if( wpo_ticket_option_max_open_tickets() > 0 ){
			if( wpo_ticket_get_count_ticketbox($user_id) >= wpo_ticket_option_max_open_tickets() ){
				### tickbox full
				return false;
			}
			else{
				return true;
			}
		}
	}
}
if( !function_exists('wpo_ticket_get_count_ticketbox') ){
	function wpo_ticket_get_count_ticketbox($user_id) {
		global $wpdb;
		$query = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE `post_author`=$user_id AND `post_type`='wp-ticket' AND `post_status`='publish'");
		return $query;
	}
}
if(!function_exists('wpo_ticket_count_ticket_status')){
	/**
	 * Count ticket status
	 * @param int $user_id
	 * @param string $status
	 */
	function wpo_ticket_count_ticket_status($user_id=0, $status='open'){
		global $wpdb;
		$where = "
				p.post_type = 'wp-ticket'
				AND p.post_status = 'publish'
			    AND pm.meta_key='wpo_ticket_status'
			    AND pm.meta_value='$status'			
		";
		if($user_id > 0){
			$where .= " AND p.post_author=$user_id";
		}
		$sql = "
			SELECT count(*) FROM $wpdb->posts p
			INNER JOIN $wpdb->postmeta pm
				ON p.ID = pm.post_id
			WHERE $where	
		";
		return $wpdb->get_var($sql);
		//return $sql;
	}
}
if(!function_exists('wpo_ticket_pre_search_myticket')){
	function wpo_ticket_pre_search_myticket($where = '') {
		if( wp_verify_nonce($_GET['ticket_search'],'ticket_search_act') ){
			if( $_GET['keyword'] ){
				$keyword = trim($_GET['keyword']);
				global $wpdb;
				$where .= " OR ($wpdb->posts.post_title LIKE '%$keyword%' OR $wpdb->posts.post_content LIKE '%$keyword%')";
			}			
		}
		return $where;
	}
}

if(!function_exists('wpo_ticket_highlight')){
	/**
	 * Hightlight keyword
	 * @param string $text
	 * @param string $key
	 * @param string $color, ex: #cccccc;
	 */
	function wpo_ticket_highlight($title){
		$color = '#ecee44';
		if(strlen(trim($_GET['keyword']))>1){
			$key = trim($_GET['keyword']);
			$text = preg_replace(
				'"(?<!\<)(?<!\w)(\pL*'.$key.'\pL*)(?!\w|[^<>]*>)"i'
				, '<b class="highlight-color" style="background-color:'.$color.'">$1</b>'
				, $title
			);		
			return $text;			
		}
		else return $title;
	}
	
	add_filter('the_title', 'wpo_ticket_highlight');
	add_filter('the_content', 'wpo_ticket_highlight');
}
if(!function_exists('wpo_ticket_check_enable_recaptcha')){
	/**
	 * Check if enable re-captcha and public+private key OK
	 * return true
	 */
	function wpo_ticket_check_enable_recaptcha() {
		if( wpo_ticket_option_enable_recaptcha()=='yes' && wpo_ticket_option_recaptcha_publish_key()!='' && wpo_ticket_option_recaptcha_private_key()!='' ){
			return true;
		}
		else return false;
	}
}
if(!function_exists('wpo_ticket_check_shortcode')){
	/**
	 * check shortcode in content
	 * @param unknown_type $shortcode
	 * @param unknown_type $guid
	 * @param return true if available, else return false
	 */
	function wpo_ticket_check_shortcode($shortcode = NULL, $guid) {
		if(!$shortcode || !$guid){
			return false;;
		}
		$str = stripos($guid, 'page_id=');
		if( $str !==false ){
			$post_id = (int)substr($guid, $str+8);
			if($post_id){
				$content = wpo_ticket_get_content_from_id($post_id);
				if( strpos($content, $shortcode) !== false ){
					return strpos($content, $shortcode);
				}
				else{
					return false;
				}
			}
		}
	}
}
if(!function_exists('wpo_ticket_get_id_from_guid')){
	/**
	 * 
	 * @param url $guid
	 */
	function wpo_ticket_get_id_from_guid($guid) {
		$str = stripos($guid, 'page_id=');
			if( $str !==false ){
			$post_id = (int)substr($guid, $str+8);
			if($post_id){
				return $post_id;
			}
			return false;
		}		
	}
}
if(!function_exists('wpo_ticket_get_content_from_id')){
	function wpo_ticket_get_content_from_id($post_id) {
		if(!$post_id)
			return;
		$post = get_post($post_id);
		return $post->post_content;
	}
}
