<?php
if( !defined('ABSPATH') )
	exit();
?>
<h2><?php _e('Layout','wpo');?></h2>
<?php 
	$yesno = wpo_ticket_yesno();
?>
<form name="ticket_save_settings" id="ticket_save_settings" action="" method="post">
<table class="form-table">
	<tbody>
		<tr valign="top"><td colspan="2"><h3><?php _e('Layout','wpo');?></h3></td></tr>		
		<tr valign="top">
			<th scope="row"><?php _e('<strong>Show login form on My Ticket page</strong>, <i>If User is not logged in.</i>','wpo');?></td>
			<td>
				<select class="regular-text" name="wpo_ticket_option_show_loginform_mytickets">
				<?php 
					foreach ($yesno as $k=>$v){
						?>
							<option <?php if( wpo_ticket_option_show_loginform_mytickets()==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v;?></option>
						<?php 
					}
				?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('<strong>Show login form on Create New Ticket page</strong>, <i>If User is not logged in.</i>','wpo');?></td>
			<td>
				<select class="regular-text" name="wpo_ticket_option_show_loginform_createticket">
				<?php 
					foreach ($yesno as $k=>$v){
						?>
							<option <?php if( wpo_ticket_option_show_loginform_createticket()==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v;?></option>
						<?php 
					}
				?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('<span class="label label-important">Required</span> <strong>My Tickets page</strong>','wpo');?></td>
			<td>
				<?php 
					$pages = get_pages();
					if($pages){
						echo '<select class="regular-text" name="wpo_ticket_get_url_myticket">';
							foreach ($pages as $pages){
								?>
									<option <?php if( wpo_ticket_get_url_myticket()==$pages->guid ): echo 'selected';endif;?> value="<?php echo $pages->guid;?>"><?php echo $pages->post_title;?></option>
								<?php 
							}
						echo '</select>';
					}
				?>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('<span class="label label-important">Required</span> <strong>Create Ticket page</strong>','wpo');?></td>
			<td>
				<?php 
					$pages = get_pages();
					if($pages){
						echo '<select class="regular-text" name="wpo_ticket_get_url_createticket">';
							foreach ($pages as $pages){
								?>
									<option <?php if( wpo_ticket_get_url_createticket()==$pages->guid ): echo 'selected';endif;?>  value="<?php echo $pages->guid;?>"><?php echo $pages->post_title;?></option>
								<?php 
							}
						echo '</select>';
					}
				?>
			</td>
		</tr>													
		<tr valign="top"><td colspan="2">
			<input type="hidden" name="action" value="ticket_save_settings">
			<button type="submit" class="button button-primary button-large" type="button"><?php _e('Save settings','wpo');?></button>
		</td></tr>
	</tbody>
</table>
</form>


